//
// Copyright (C) 2006, NinjaTrader LLC <ninjatrader@ninjatrader.com>.
// NinjaTrader reserves the right to modify or overwrite this NinjaScript component with each release.
//

#region Using declarations
using System;
using System.ComponentModel;
using System.Drawing;
using System.Drawing.Drawing2D;
using System.Xml.Serialization;
using NinjaTrader.Data;
using NinjaTrader.Gui.Chart;
#endregion

#region NinjaScript generated code. Neither change nor remove.
// This namespace holds all indicators and is required. Do not change it.
namespace NinjaTrader.Indicator
{
    public partial class Indicator : IndicatorBase
    {
        private ncatPeriodBars[] cachencatPeriodBars = null;

        private static ncatPeriodBars checkncatPeriodBars = new ncatPeriodBars();

        /// <summary>
        /// The indicator regroups single bars to display them as Multi Period Boxes
        /// </summary>
        /// <returns></returns>
        public ncatPeriodBars ncatPeriodBars(int opacity, int period, bool shortLogo)
        {
            return ncatPeriodBars(Input, opacity, period, shortLogo);
        }

        /// <summary>
        /// The indicator regroups single bars to display them as Multi Period Boxes
        /// </summary>
        /// <returns></returns>
        public ncatPeriodBars ncatPeriodBars(Data.IDataSeries input, int opacity, int period, bool shortLogo)
        {
            if (cachencatPeriodBars != null)
                for (int idx = 0; idx < cachencatPeriodBars.Length; idx++)
                    if (cachencatPeriodBars[idx].Opacity == opacity && cachencatPeriodBars[idx].Period == period && cachencatPeriodBars[idx].ShortLogo == shortLogo && cachencatPeriodBars[idx].EqualsInput(input))
                        return cachencatPeriodBars[idx];

            lock (checkncatPeriodBars)
            {
                checkncatPeriodBars.Opacity = opacity;
                opacity = checkncatPeriodBars.Opacity;
                checkncatPeriodBars.Period = period;
                period = checkncatPeriodBars.Period;
                checkncatPeriodBars.ShortLogo = shortLogo;
                shortLogo = checkncatPeriodBars.ShortLogo;

                if (cachencatPeriodBars != null)
                    for (int idx = 0; idx < cachencatPeriodBars.Length; idx++)
                        if (cachencatPeriodBars[idx].Opacity == opacity && cachencatPeriodBars[idx].Period == period && cachencatPeriodBars[idx].ShortLogo == shortLogo && cachencatPeriodBars[idx].EqualsInput(input))
                            return cachencatPeriodBars[idx];

                ncatPeriodBars indicator = new ncatPeriodBars();
                indicator.BarsRequired = BarsRequired;
                indicator.CalculateOnBarClose = CalculateOnBarClose;
#if NT7
                indicator.ForceMaximumBarsLookBack256 = ForceMaximumBarsLookBack256;
                indicator.MaximumBarsLookBack = MaximumBarsLookBack;
#endif
                indicator.Input = input;
                indicator.Opacity = opacity;
                indicator.Period = period;
                indicator.ShortLogo = shortLogo;
                Indicators.Add(indicator);
                indicator.SetUp();

                ncatPeriodBars[] tmp = new ncatPeriodBars[cachencatPeriodBars == null ? 1 : cachencatPeriodBars.Length + 1];
                if (cachencatPeriodBars != null)
                    cachencatPeriodBars.CopyTo(tmp, 0);
                tmp[tmp.Length - 1] = indicator;
                cachencatPeriodBars = tmp;
                return indicator;
            }
        }
    }
}

// This namespace holds all market analyzer column definitions and is required. Do not change it.
namespace NinjaTrader.MarketAnalyzer
{
    public partial class Column : ColumnBase
    {
        /// <summary>
        /// The indicator regroups single bars to display them as Multi Period Boxes
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ncatPeriodBars ncatPeriodBars(int opacity, int period, bool shortLogo)
        {
            return _indicator.ncatPeriodBars(Input, opacity, period, shortLogo);
        }

        /// <summary>
        /// The indicator regroups single bars to display them as Multi Period Boxes
        /// </summary>
        /// <returns></returns>
        public Indicator.ncatPeriodBars ncatPeriodBars(Data.IDataSeries input, int opacity, int period, bool shortLogo)
        {
            return _indicator.ncatPeriodBars(input, opacity, period, shortLogo);
        }
    }
}

// This namespace holds all strategies and is required. Do not change it.
namespace NinjaTrader.Strategy
{
    public partial class Strategy : StrategyBase
    {
        /// <summary>
        /// The indicator regroups single bars to display them as Multi Period Boxes
        /// </summary>
        /// <returns></returns>
        [Gui.Design.WizardCondition("Indicator")]
        public Indicator.ncatPeriodBars ncatPeriodBars(int opacity, int period, bool shortLogo)
        {
            return _indicator.ncatPeriodBars(Input, opacity, period, shortLogo);
        }

        /// <summary>
        /// The indicator regroups single bars to display them as Multi Period Boxes
        /// </summary>
        /// <returns></returns>
        public Indicator.ncatPeriodBars ncatPeriodBars(Data.IDataSeries input, int opacity, int period, bool shortLogo)
        {
            if (InInitialize && input == null)
                throw new ArgumentException("You only can access an indicator with the default input/bar series from within the 'Initialize()' method");

            return _indicator.ncatPeriodBars(input, opacity, period, shortLogo);
        }
    }
}
#endregion
